package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This class extends JPanel.  It illustrates the use of toolbox JDBC visual
// classes.  User selects SQL Query using SQLQueryBuilderPane, and is provided
// with a choice to display results in a JTable (class SQLResultSetTablePane), or
// in a record form pane (class SQLResultSetFormPane).


import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.ibm.as400.vaccess.ErrorDialogAdapter;
import com.ibm.as400.vaccess.SQLConnection;
import com.ibm.as400.vaccess.SQLQueryBuilderPane;
import com.ibm.as400.vaccess.SQLResultSetFormPane;
import com.ibm.as400.vaccess.SQLResultSetTablePane;


public class JDBCExample extends JPanel implements ActionListener{


private ToolboxDemo    parentFrame;


private JLabel			l1,l2,l3,l4,l5;
private JTextField	t2;
private JScrollPane  scrollpane=new JScrollPane();


private JButton		populatePB=new JButton("Show in JTable");
private JButton		resetPB=new JButton("Assign AS/400");
private JButton		showPB=new JButton("Show in pane");
private JButton		endPB=new JButton("Exit");


// This connection is shared by all components.
private static SQLConnection connection;


// This error handler is shared by all components.
private static ErrorDialogAdapter errorHandler;


// The query builder pane.
private static SQLQueryBuilderPane queryBuilderPane;





































































public JDBCExample(ToolboxDemo f) {
	parentFrame=f;
	t2=new JTextField(parentFrame.AS400Name,9);
	l1=new JLabel("This panel demonstrates use of JDBC Visual parts: SQLQueryBuilderPane,");
	JLabel l1a=new JLabel("SQLResultSetFormPane, and SQLResultSetTablePane");
	l2=new JLabel("AS400:");
	populatePB.addActionListener(this);
	populatePB.setToolTipText("Show selected query in SQLResultSetTablePane");
	resetPB.addActionListener(this);
	resetPB.setToolTipText("Reset SQLQueryBuilderPane with AS/400");
	showPB.addActionListener(this);
	showPB.setToolTipText("Show selected query in SQLResultSetFormPane");
	endPB.addActionListener(this);


	// Report any errors to the user.
	errorHandler = new ErrorDialogAdapter (f);


	// Create an SQL query builder pane to present the query
	// builder.
	queryBuilderPane = new SQLQueryBuilderPane ();
	queryBuilderPane.addErrorListener (errorHandler);
	queryBuilderPane.setMaximumSize(new Dimension(500,500));
	queryBuilderPane.setPreferredSize(new Dimension(500,500));
	scrollpane.getViewport().add(queryBuilderPane);
	queryBuilderPane.setToolTipText("This is an SQL query builder.");
	scrollpane.setToolTipText("This is an SQL query builder.");


	// Position items on panel.
	setLayout(new GridBagLayout());
	addit1(l1,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(l1a,0,1,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(scrollpane,0,2,10,10,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,11,2,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(t2,11,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(resetPB,13,3,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(showPB,13,5,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
	addit1(populatePB,13,7,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,1,1,1,1);
//	addit1(endPB,13,9,1,1,
//		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
//		10,1,1,1,1,1);
	addit1(new JLabel(""),13,10,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
}
public void actionPerformed(ActionEvent e) {
	try {
		if(e.getSource() == resetPB) {
			// load SQLQueryBuilder pane with the selected AS/400
			try {
		 		parentFrame.status.setText("Connecting ....");
				connection = new SQLConnection ("jdbc:as400://" + t2.getText().trim());
				queryBuilderPane.setConnection(connection);
		 		parentFrame.status.setText("Loading data from "+t2.getText().trim());
				queryBuilderPane.load();
			} catch (Exception ee) {
				System.out.println ("ERROR: " + ee.getMessage());
			}
	 		parentFrame.status.setText("Idle.");
		}
		if(e.getSource() == showPB) {
			// show selected query in a record panel
	  		showFormPane (queryBuilderPane.getQuery ());
		}
		if(e.getSource() == populatePB) {
			// show selected query in a JTable:
	  		showTablePane (queryBuilderPane.getQuery ());
		}
		if(e.getSource() == endPB) {
			System.exit(0);
	 	}
	} catch(Exception e1) {
	}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)getLayout()).setConstraints(c, gbc);
	add(c);
}
	// show results of query on a record pane
	private static void showFormPane (String query)
	{
		// Create a new frame for the results of the query.
		JFrame f = new JFrame (query);


		// Create a SQL result set form pane to present the results
		// of the query.  Load the results from the system.
		SQLResultSetFormPane formPane = new SQLResultSetFormPane (connection, query);
		formPane.addErrorListener (errorHandler);
		formPane.load ();


		// Layout the frame with the form pane.
		f.getContentPane ().setLayout (new BorderLayout ());
		f.getContentPane ().add ("Center", formPane);
		f.pack ();
		f.show ();
	}
// show selected query in a JTable
public void showTablePane(String query) {
		// Create a new frame for the results of the query.
		JFrame f = new JFrame (query);


		// Create a SQL result set form pane to present the results
		// of the query.  Load the results from the system.
		SQLResultSetTablePane tablePane = new SQLResultSetTablePane (connection, query);
		tablePane.addErrorListener(errorHandler);
		tablePane.load();


		// Layout the frame with the form pane.
		f.getContentPane().setLayout(new BorderLayout());
		f.getContentPane().add("Center", tablePane);
		f.pack();
		f.show();
}
}
