package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.ibm.as400.access.AS400;
import com.ibm.as400.access.JavaApplicationCall;


public class JavaExecutionPanel extends JFrame implements Runnable, ActionListener{
	
private JLabel			l0=new JLabel("This panel allows remote execution of the specified class.  It uses ");
private JLabel			l0A=new JLabel("JavaApplicationCall class to make the call.  Standard Input / Output");
private JLabel			l0B=new JLabel("is redirected to the JTextArea's below.");
private JLabel			l0C=new JLabel(" ");
private JLabel			l1=new JLabel("AS/400");
private JLabel			l2=new JLabel("Program:");
private JLabel			l3=new JLabel("In dir.:");
private JLabel			l4=new JLabel("stdout:");
private JLabel			l5=new JLabel("stdin:");
private JTextField		t1=new JTextField(9);
private JTextField		t2=new JTextField(25);
private JTextField		t3=new JTextField(".:",6);
private JTextField		stdin=new JTextField();


private JavaApplicationCall jCall = null;


private JPanel			mainP=new JPanel();
private TextField		status=new TextField("Idle");
private JTable			table;
private JScrollPane 	sp=new JScrollPane();
private JScrollPane 	sp1=new JScrollPane();
private JTextArea    	out=new JTextArea();
private JButton			callPB=new JButton("Call");
private JButton			endPB=new JButton("Clear");




public  AS400		 	AS400Connection;
public	String			pgm, javaDir, javaFile;
public	String			cinLine="";
private	RunCmd 			runThread;
public	boolean			alive=true;
public	boolean			firstTime=true;







































public JavaExecutionPanel(AS400 conn, String p) {
	super();
	AS400Connection=conn;
	pgm=p;
	setTitle("Calling an AS/400 Java program");
	javaDir = pgm.substring(0, pgm.lastIndexOf("/"));
	javaFile = pgm.substring(pgm.lastIndexOf("/") + 1, pgm.lastIndexOf("."));
	callPB.addActionListener(this);
	endPB.addActionListener(this);
	stdin.addActionListener(this);
	
	jCall = new  JavaApplicationCall(AS400Connection);
	
	t1.setEnabled(false);
	t1.setText(conn.getSystemName());
	t2.setText(javaFile);
	t3.setText(javaDir);
	out.setEnabled(false);
	status.setEnabled(false);


	sp.getViewport().add(out);
	sp.setMinimumSize(new Dimension(300,280));
	sp.setPreferredSize(new Dimension(300,280));
	mainP.setLayout(new GridBagLayout());


	//set up tool tip text
	t3.setToolTipText("Enter class path here.  Use ':' as delimeter");
	callPB.setToolTipText("Call java program using classpath");
	endPB.setToolTipText("Clear contents of stdout text area");
	out.setToolTipText("JTextArea displays all output from program.");
	stdin.setToolTipText("Contents are fed to called program as input stream.");
	
	addit1(l0,0,0,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,0,1,1,1);
	addit1(l0A,0,1,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,0,1,1,1);
	addit1(l0B,0,2,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,0,1,1,1);
	addit1(l0C,0,3,10,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,1,0,1,1,1);
	addit1(l1,0,10,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l2,0,11,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(l3,0,12,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(t1,1,10,2,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(t2,1,11,2,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(t3,1,12,2,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(l4,0,15,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(l5,0,20,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,10,1,1,1,1);
	addit1(callPB,5,12,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		1,1,1,1,1,1);
	addit1(endPB,6,12,1,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(sp,0,16,10,1,
		java.awt.GridBagConstraints.BOTH,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(stdin,0,21,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	addit1(status,0,23,10,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	getContentPane().add(mainP);
	pack();
	Thread outputThread = new Thread(this);
	outputThread.setName("I/O Handler");
	outputThread.start();
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent evt) {
			alive=false;
		}
	});
  }
public void actionPerformed(ActionEvent e) {
	if (e.getSource() == callPB) {
		try {
			javaFile=t2.getText().trim();
			javaDir=t3.getText().trim();
			pgm = t2.getText().trim();
			status.setText("=> calling " + javaFile + " in dir:\"" + javaDir + "\"");
			out.append("=> calling " + javaFile + " in dir:\"" + javaDir + "\"\n");
			jCall.setClassPath(t3.getText().trim());
			jCall.setJavaApplication(t2.getText().trim());
			runThread = new RunCmd(jCall, out, status);
			runThread.start();
			
/*			if (firstTime) {
				firstTime=false;
				runThread.start();
			} else
				runThread.run();
*/				
			stdin.requestFocus();
		} catch (Exception ee) {
			out.append("Exception: " + ee.toString() + "\n");
		};
	}
	if (e.getSource() == endPB) {
		// clear output text area
		out.setText("");
	}
	if (e.getSource() == stdin) {
		jCall.sendStandardInString(stdin.getText().trim());
		stdin.setText("");
	}
}
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)mainP.getLayout()).setConstraints(c, gbc);
	mainP.add(c);
}
public void run() {
	while (alive) {
		String s = jCall.getStandardOutString();
		if (s != null)
			out.append(s+"\n");
		else
			try {
				Thread.sleep(5);
			} catch (Exception e) {
			}
	}
}
}
