package com.ibm.etools.iseries.examples.toolboxdemo;


// Licensed Material - Property of IBM
// (C) Copyright IBM Corp. 1997, 1998 - All Rights Reserved
//
// DISCLAIMER:
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided 'AS IS',
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.


// This application presents user with a JTabbedPane.  Each page in the tabbed pane
// illustrates the use of selected AS/400 Toolbox classes.


// NOTES: - To run this application please select this class, and
//          click on Run on the tool bar.
//        - Size of visual parts of this application precludes its use in screen
//          resolutions lower than 1024 X 768.


import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.TextField;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
import javax.swing.UIDefaults;
import javax.swing.UIManager;


public class ToolboxDemo extends JFrame  {


public		String			AS400Name=null;
private 	JTabbedPane		tabbedPane=new JTabbedPane(SwingConstants.RIGHT);
TextField 	status =		new TextField("Idle.");


public ToolboxDemo() {
	setTitle("AS400 Toolbox Test bed");
	setBackground(new Color(java.awt.SystemColor.window.getRGB()));
	setResizable(true);
  }
// add Component to JPanel, using passed GridbagLayout - related values
private void addit1(JPanel jp,Component c, int x, int y, int xw, int yw,
						int fill, int anchor, double weightx, double weighty,
						int top, int left, int bottom, int right) {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx=x;
	gbc.gridy=y;
	gbc.gridwidth=xw;
	gbc.gridheight=yw;
	gbc.fill=fill;
	gbc.anchor=anchor;
	gbc.weightx=weightx;
	gbc.weighty=weighty;
	if (top+bottom+left+right > 0)
		gbc.insets = new Insets(top, left, bottom, right);
	// Set constraint for the component
	((GridBagLayout)jp.getLayout()).setConstraints(c, gbc);
	jp.add(c);
}
public static void main(String s[]) {
	// set default colors to system defaults
	try {
  		UIDefaults a = UIManager.getLookAndFeelDefaults();
 		Color windowColor = new Color(java.awt.SystemColor.window.getRGB());
		Color controlColor = new Color(java.awt.SystemColor.control.getRGB());
		Color shadowColor = new Color(java.awt.SystemColor.controlShadow.getRGB());
		Color highlightColor = new Color(java.awt.SystemColor.controlLtHighlight.getRGB());
		a.put("Table.background",windowColor);
		a.put("Tree.background",windowColor);
		a.put("Tree.backgroundNonSelectionColor",windowColor);
		a.put("Tree.borderSelectionColor",windowColor);
		a.put("ToggleButton.background",windowColor);
		a.put("ComboBox.background",windowColor);
		a.put("TextField.background",windowColor);
		a.put("TextArea.background",windowColor);
		a.put("window",windowColor);
		a.put("RadioButton.background",windowColor);
		a.put("EditorPane.background",controlColor);
		a.put("CheckBox.background",windowColor);
		a.put("TextField.disabledBackground",windowColor);
		a.put("Panel.background",controlColor);
		a.put("ScrollBar.foreground",controlColor);
		a.put("Button.background",controlColor);
		a.put("ScrollBar.thumb",controlColor);
		a.put("TableHeader.background",controlColor);
		a.put("ScrollBar.track",highlightColor);
	} catch(Exception e)	{
		System.out.println(e);
	}
	ToolboxDemo p= new ToolboxDemo();
	String result=null;
	result = JOptionPane.showInputDialog(p, "Please enter default iSeries server:");
	if (result == null)
		result="";
	p.AS400Name=result;
	p.status.setEnabled(false);
	JPanel panel1=new JPanel(new GridBagLayout());
	panel1.setLayout(new GridBagLayout());
	p.addit1(panel1,p.tabbedPane,0,0,6,1,
		java.awt.GridBagConstraints.NONE,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	p.addit1(panel1,p.status,0,2,6,1,
		java.awt.GridBagConstraints.HORIZONTAL,java.awt.GridBagConstraints.NORTHWEST,
		10,10,1,1,1,1);
	p.getContentPane().add(panel1);
	p.tabbedPane.addTab("Logo",new LogoExample(p));
	p.tabbedPane.addTab("JDBC Handcoded",new JDBCManualExample(p));
	p.tabbedPane.addTab("JDBC Toolbox",new JDBCExample(p));
	p.tabbedPane.addTab("Users & groups",new UserExample(p));
	p.tabbedPane.addTab("Jobs",new JobExample(p));
	p.tabbedPane.addTab("Calls",new CallExample(p));
	p.tabbedPane.addTab("Record I/O",new RI_OExample(p));
	p.tabbedPane.addTab("IFS",new IFSExample(p));
	p.tabbedPane.addTab("S.P.C.",new SPCExample(p));
	p.pack();
	p.addWindowListener (new WindowAdapter ()
	{
   	 public void windowClosing (WindowEvent event){
 	        System.exit (0);
	 }
	});
	p.show();
	// had to add the following NELoop.  SWT Example Launcher
	// would terminate example otherwise.
	while (true) { 
		try {
			Thread.sleep(500);
		} catch (Exception e){
			// ignore
		}
	}
}
}
